/*
 * Created on 2004/06/27
 * 
 * Author aki@www.xucker.jpn.org License Apache2.0 or Common Public License
 */
package org.jpn.xucker.playdict;

import java.io.File;

import org.eclipse.swt.SWT;
import org.eclipse.swt.dnd.Clipboard;
import org.eclipse.swt.dnd.TextTransfer;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.MenuItem;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Tray;
import org.eclipse.swt.widgets.TrayItem;
import org.jpn.xucker.commons.util.FileProperties;

public class PlayDictMain implements SelectionListener, Runnable {
    private Menu popupmenu;

    private MenuItem replaymenu;

    private MenuItem startmenu;

    private MenuItem stopmenu;

    private MenuItem setmenu;

    private MenuItem quitmenu;

    Shell shell;

    Thread thread;

    public boolean doLoop = true;

    private String beforeString;

    private SoundWord soundWord;

    private static String defaultSoundPath = "C:\\Program Files\\StarDict\\WyabdcRealPeopleTTS";

    private String lastPlay;

    private TrayItem item;
    public  Tray tray;
    private boolean doPlay = true;;

    private Image playIcon;

    private Image stopIcon;

    //private FilePreference filePreference;

    private static final String PREF_SOUNDDIR = "soundDir";

    
  
    
    Shell dialogShell;
    
    private FileProperties fileProperties;

    private String FREETTS_JMDICT="freetts_jmdict_wav";
    
    



    public void updatePreference(DictPreference preference) {
        String newPath = preference.getSoundDirectory();
        soundWord.setSoundDir(new File(newPath));
        
        fileProperties.set(PREF_SOUNDDIR, newPath);
        
        soundWord.setAllowFreeTTS(preference.isFreeTTSJMDict());
        String result=""+preference.isFreeTTSJMDict();
        fileProperties.set(FREETTS_JMDICT,result);
        fileProperties.save();
        
        preference.getShell().dispose();
    }

    public PlayDictMain(Shell shell) {
        soundWord = new SoundWord(new File(defaultSoundPath), SoundWord.AUTO);
        soundWord.setFreettsZipFile(FileProperties
                .searchFileAroundClass("freetts_jmdict_wav.zip"));
      //  System.out.println(soundWord.getFreettsZipFile());
        this.shell = shell;
        //create menu
        popupmenu = new Menu(shell, SWT.POP_UP);

        replaymenu = new MenuItem(popupmenu, SWT.PUSH);
        replaymenu.setText("ōĐ");
        replaymenu.addSelectionListener(this);
        MenuItem separatemenu5 = new MenuItem(popupmenu, SWT.SEPARATOR);
        //	    Jn
        startmenu = new MenuItem(popupmenu, SWT.RADIO);
        startmenu.setText("Jn");
        startmenu.addSelectionListener(this);
        //	    ~
        stopmenu = new MenuItem(popupmenu, SWT.RADIO);
        stopmenu.setText("~");
        stopmenu.addSelectionListener(this);
        MenuItem separatemenu3 = new MenuItem(popupmenu, SWT.SEPARATOR);
        //	    ݒ
        setmenu = new MenuItem(popupmenu, SWT.PUSH);
        setmenu.setText("ݒ");
        setmenu.addSelectionListener(this);
        MenuItem separatemenu6 = new MenuItem(popupmenu, SWT.SEPARATOR);
        //	    I
        quitmenu = new MenuItem(popupmenu, SWT.PUSH);
        quitmenu.setText("I");
        quitmenu.addSelectionListener(this);

        startmenu.setSelection(true);
        shell.setText("simpleButton");
        shell.setBounds(0, 0, 200, 100);
        shell.setLayout(new FillLayout(SWT.VERTICAL));

        tray = Display.getCurrent().getSystemTray();
        item = new TrayItem(tray, SWT.NONE);
        playIcon = new Image(Display.getCurrent(), this.getClass()
                .getClassLoader().getResourceAsStream(
                        "org/jpn/xucker/playdict/resource/icon.png"));
        stopIcon = new Image(Display.getCurrent(), this.getClass()
                .getClassLoader().getResourceAsStream(
                        "org/jpn/xucker/playdict/resource/stop.png"));
        item.setImage(playIcon);
        item.setToolTipText("Nbv{[hpPPlayer");
        item.addSelectionListener(this);

        item.addListener(SWT.MenuDetect, new Listener() {
            public void handleEvent(Event event) {
                popupmenu.setVisible(true);
            }
        });

        loadPreference();
        /*
         * menu1=new Menu(item); item.setMenu(menu1); pushmenu1=new
         * MenuItem(menu1,SWT.PUSH); pushmenu1.setText("null1");
         * pushmenu1.addSelectionListener(this);
         */
        thread = new Thread(this);
        thread.start();
    }

    /**
     *  
     */
    private void loadPreference() {
        File file = FileProperties
                .searchFileAroundClass("Nbv{[hpPPlayer.exe");
        if (!file.exists()) {
            throw new RuntimeException("File Not Found:Nbv{[hpPPlayer.exe");

        }
        
        String soundDir=null;
        fileProperties=new FileProperties(new File(file.getParentFile(), "PlayDict.properties"));
        
        soundDir=fileProperties.get(PREF_SOUNDDIR);
        //filePreference = new FilePreference(preference);

      //  System.out.println("sounddir:"+soundDir);
       // System.out.println(soundWord.getSoundDir().getAbsolutePath());
        if (soundDir != null) {
          //  System.out.println("sounddir " + soundDir);
            soundWord.setSoundDir(new File(soundDir));
        }
        
        String isFreeTTSZip=fileProperties.get(FREETTS_JMDICT);
        //System.out.println(isFreeTTSZip);
        if(isFreeTTSZip==null ){
            soundWord.setAllowFreeTTS(true);
        }else{
            if(isFreeTTSZip.equals("true")){
                soundWord.setAllowFreeTTS(true);
            }
        }
        //System.out.println(soundWord.isAllowFreeTTS());
    }

    public static void main(String[] args) {
        Shell shell=null;
        PlayDictMain main =null;
        Display display =null;
        try{
        display= new Display();
         shell= new Shell(display);

        main= new PlayDictMain(shell);

        //shell.open();
        //shell.setVisible(false);
        while (!shell.isDisposed()) {

            if (!display.readAndDispatch()) {
                display.sleep();
            }
        }
        }catch(Exception e){
            System.out.println("unknown error happen.");
            e.printStackTrace();
            
        }finally{
            //System.out.println("closing");
            
            if(main!=null){
                main.doLoop = false;
                if(!main.tray.isDisposed()){
                    System.out.println("tray not disposed");
                    main.tray.dispose();
                }
            }
            if(display!=null){
                display.dispose();
            }
           
        }
      //  System.out.println("end");
      System.exit(0);
    }

    public void widgetSelected(SelectionEvent event) {

        Object target = event.getSource();
        if (target == null) {
            //
            System.out.println("null target");
        } else if (target == item) {
            do_replaymenu();
        }
        //	  	      ōĐ
        else if (target == replaymenu) {
            do_replaymenu();
        }
        //	      Jn
        else if (target == startmenu) {
            do_startmenu();
        }
        //	      ~
        else if (target == stopmenu) {
            do_stopmenu();
        }
        //	      ݒ
        else if (target == setmenu) {
            do_setmenu();
        }
        //	      I
        else if (target == quitmenu) {
            do_quitmenu();
        }

    }

    /**
     *  
     */
    private void do_replaymenu() {
        if (lastPlay != null) {
            if (isFindWord(lastPlay)) {
                playWord(lastPlay);
            }
        }
    }

    //	    Jn
    public void do_startmenu() {
        // System.out.println("startmenu");
        item.setImage(playIcon);
        doPlay = true;
    }

    //	      ~
    public void do_stopmenu() {
        //System.out.println("stopmenu");
        item.setImage(stopIcon);
        doPlay = false;
    }

    //	      ݒ
    public void do_setmenu() {
        if(dialogShell==null || dialogShell.isDisposed()){
       dialogShell = new Shell(shell, SWT.SYSTEM_MODAL | SWT.CLOSE);
        DictPreference preference = new DictPreference(this, dialogShell);
        //System.out.println(soundWord.getSoundDir().getAbsolutePath());
        preference.setSoundDirectory(soundWord.getSoundDir().getAbsolutePath());
        preference.setFreeTTSJMDict(soundWord.isAllowFreeTTS());
        dialogShell.open();
        }else{
            dialogShell.setFocus();
        }
    }

    //	      I

    public void do_quitmenu() {
        shell.close();
        this.doLoop=false;
        tray.dispose();//important
        
        shell.dispose();
        }

    public void widgetDefaultSelected(SelectionEvent arg0) {
        // TODO Auto-generated method stub

    }

    /*
     * (non-Javadoc)
     * 
     * @see java.lang.Runnable#run()
     */

    public void run() {
        while (doLoop && !shell.isDisposed()) {
            
                if (doPlay ) {
                    //System.out.println("ok"); 
                    shell.getDisplay().syncExec(new MonitorClipboard());
                   
                }
                try {
                    Thread.sleep(100);
                } catch (InterruptedException e) {
                    // TODO Auto-generated catch block
                    e.printStackTrace();
                }
            
        }
       
    }

    /**
     * @param value
     */
    private void playWord(String value) {
        //System.out.println("play "+value);
        // TODO Auto-generated method stub
        //  System.out.println(value);
        try{
        soundWord.playSound(value);
        }catch(Error e){
            do_quitmenu();
        }
    }

    /**
     * @param value
     * @return
     */
    private boolean isFindWord(String value) {
        return soundWord.isExist(value);
    }

    public class SetMenu extends Thread {

        public void run() {
           

        }
    }

    public class MonitorClipboard extends Thread{
        private int MAX_FILE_NAME=1024;

        public void run(){
            String value = getCurrentClipboard();
           // System.out.println(value);
            if (value != null) {
                if (!value.equals(beforeString)) {
                    if (isValidWord(value)) {
                        playWord(value);

                        lastPlay = value;
                        if (lastPlay != null) {
                            replaymenu.setText("ōĐ(" + lastPlay + ")");
                        }
                        
                    }
                }
                beforeString = value;
            }
        }

        /**
         * @param value
         * @return
         */
        private boolean isValidWord(String value) {
           if(value.length()<MAX_FILE_NAME){
               String nonfileString="\\/:*?\"< >|";
             
               for(int i=0;i<nonfileString.length();i++){
                   if(value.indexOf(nonfileString.charAt(i))!=-1){
                       return false;
                   }
               }
               
               return soundWord.isExist(value);
               
           }else{
               return false;
           }
        }
    }
    /**
     * @return
     */
    private   String getCurrentClipboard() {

        if(!shell.isDisposed()){
        Clipboard cp= new Clipboard(shell.getDisplay());
        TextTransfer transfer=TextTransfer.getInstance();
        
        String v[]=cp.getAvailableTypeNames();
        
        for(int i=0;i<v.length;i++){
           if(v[i].equals("CF_TEXT")){
               return (String)cp.getContents(transfer);
           }
        }
        cp.dispose();
        }
     return null;   
    }
}